﻿///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
Auto cutter script by Fred CRETET

generate a "cut by hand" on a new layer from alpha channel

fcretet"AT"gmail.com

*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LastLayercreated = 0;
 
 function Ce_soir_buildUI(thisObj) {
     myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "Habillage auto", [100, 100, 1200, 800]);
	//Jeff Almasol's solution to fix text color
     var winGfx = myPanel.graphics;
     var darkColorBrush = winGfx.newPen(winGfx.BrushType.SOLID_COLOR, [0,0,0], 1);
	 
	myPanel.TxtPrechoke = myPanel.add("StaticText", [30, 10,200,30], "0			Pre-Choke			100");
	myPanel.SliderChoke = myPanel.add ("slider", [30, 25,200, 40], 30, 0, 100,0);
	myPanel.TxtValueChoke = myPanel.add("StaticText", [200, 30,250,50],myPanel.SliderChoke.value );
	myPanel.ButApply = myPanel.add("button", [35, 50,125, 70], "Apply");	
	myPanel.ButRemove = myPanel.add("button", [125, 50,215, 70], "Remove");		

	myPanel.SliderChoke.onChanging = updateSlider;
	myPanel.ButApply.onClick = Apply;
	myPanel.ButRemove.onClick = RemoveAutotraced;
	
}


function updateSlider()
{
	myPanel.TxtValueChoke.text = Math.round(myPanel.SliderChoke.value);
}

function RemoveAutotraced()
{
	if( LastLayercreated == 0)
	{
		return;
	}
	LastLayercreated.remove();
	LastLayercreated = 0;
}

function Apply()
{
	app.beginUndoGroup("Auto Cutter");
	var comp = app.project.activeItem;
	if( app.project.activeItem == null)
	{
		return;		
	}
	var layerCollection = comp.selectedLayers;
	NumLayerBeforeAutotrace = comp.numLayers;
	if(layerCollection.length == 0 ||  layerCollection.length >1)
	{
		return;
	}
	layerCollection[0].Effects.addProperty("ADBE Simple Choker").property(2).setValue(Math.round(myPanel.SliderChoke.value)*-1);
	app.executeCommand(3044); // launch auto trace palette
	layerCollection[0].Effects(layerCollection[0].Effects.numProperties).remove();
	if(NumLayerBeforeAutotrace == comp.numLayers-1)  	// Auto trace press Ok ?
	{
		var layerAutoTrace = comp.layer(1);
		layerAutoTrace.moveAfter(layerCollection[0]);
		layerCollection[0].selected=1;
		NumberMask = layerAutoTrace.property("Masks").numProperties;
		for (n=1 ; n <= NumberMask ; n++)
		{
				var MaskShape = layerAutoTrace.property("Masks").property(n).property("maskShape").value;
				var InTanArray = MaskShape.inTangents;
				var OutTanArray = MaskShape.outTangents;
				var NVertex = MaskShape.vertices.length;
				for (Vtx=0 ; Vtx<NVertex ; Vtx++)
				{
					InTanArray[Vtx] = [0,0];
					OutTanArray[Vtx] = [0,0];
				}
				MaskShape.inTangents=InTanArray;
				MaskShape.outTangents=OutTanArray;
				layerAutoTrace.property("Masks").property(n).property("maskShape").setValue(MaskShape);
		}
		layerAutoTrace.parent=layerCollection[0];
		LastLayercreated = layerAutoTrace;
	}
	app.endUndoGroup();
}

{
   var myPanel;
   Ce_soir_buildUI(this);
}
